#!/usr/bin/perl
###################################################################
###      File: /home/users2/schmid/src/TBProgs/TMod/normalise.perl#
###    Author: Helmut Schmid                                    ###
###   Purpose:                                                  ###
###   Created: Wed Apr 30 13:06:38 2003                         ###
###  Modified: Fri Feb 10 17:03:25 2006 (schmid)                ###
### Copyright: Institut fuer maschinelle Sprachverarbeitung     ###
###               Universitaet Stuttgart                        ###
###################################################################

while (<>) {
  # generate a flat tree for unparsed sentences
  if (s/^No parse for: \"(.*)\"$/$1/) {
    print "(TOP ";
    foreach $w (split) {
      if ($w eq "'") {
	print "(SQ $w)";
      }
      elsif ($w =~ /^[,;:\(\)\"\'\`\.\!\?-]+$/) {
	print "(, $w)";
      }
      else {
	print "(NN $w)";
      }
    }
    print ")\n";
  }
  else {
    s/\s+/ /g;
    s/\(V[VHDM]/\(VB/g;
    # separate indices
    s/(([=-][0-9]+)+)/$1/g;
    # eliminate features
    s/\(\.\/\S+ /\(. /g;
    s/([A-Z-]*)(\/(\*(([A-Z]+|\?)\*)?)|0)+/$1/g;
    s/([^ ])([_+]|\\=)[^ ()*]+(\*?[ ()])/$1$3/g;
    s/(\(\*?[A-Z\$-]+)\\?\/[^ *()]*(\*?[ ()])/$1$2/g;
    s/(\(\*?[A-Z\$-]+)\\?\/[^ *()]*(\*?[ ()])/$1$2/g;
    s/\((0|(\*([A-Z?]+\*)?((-[0-9]+)+)?))\)/ $1/g;
    s///g;
    # unquote two single quotes
    s/\\([\'\$])/$1/g;
    s/\(-- --\)/\(: --\)/g;
    s/\(\.\.\. \.\.\.\)/\(: \.\.\.\)/g;
    s/\(; ;\)/\(: ;\)/g;
    s/\(\! \!\)/\(\. \!\)/g;
    s/\(\? \?\)/\(\. \?\)/g;
    s/\\=/=/g;
    s/\(\'\' \'\)/\(SQ \'\)/g;
    # unquote hashes and slashs
    s/\\([\#\/])/$1/g;
    s/ $/\n/;
    print unless /^\s*$/;
  }
}
