
/*MA****************************************************************/
/*                                                                 */
/*     File: frequency-table.h                                     */
/*   Author: Helmut Schmid                                         */
/*  Purpose:                                                       */
/*  Created: Thu Jan  2 14:55:10 2003                              */
/* Modified: Fri Jul 23 15:13:43 2004 (schmid)                     */
/*                                                                 */
/*ME****************************************************************/

#include <ext/hash_map>
using __gnu_cxx::hash_map;
using __gnu_cxx::hash;


/*****************  class FrequencyTable  **************************/

class FrequencyTable {

private:

  struct eqstr {
    bool operator()(const char* s1, const char* s2) const {
      return strcmp(s1, s2) == 0;
    }
  };

  typedef hash_map<char*, long, hash<const char*>, eqstr> SymbolMap;

  SymbolMap ST;

public:
  typedef SymbolMap::iterator iterator;

  ~FrequencyTable() {
    vector<char*> s;
    for( iterator it=ST.begin(); it!=ST.end(); it++ )
      s.push_back(it->first);
    ST.clear();
    for( size_t i=0; i<s.size(); i++ )
      free(s[i]);
  }

  long &operator[]( char *s ) {
    SymbolMap::iterator it=ST.find(s);
    if (it != ST.end())
      return it->second;

    // insert the new symbol into the tables
    char *r = strdup(s);
    return ST.insert(SymbolMap::value_type(r, 0)).first->second;
  }

  iterator find( char *s ) { return ST.find(s); }
  iterator begin() { return ST.begin(); }
  iterator end()   { return ST.end(); }
  size_t   size()  { return ST.size(); }
};

