#!/bin/sh
###################################################################
###      File: make-grammar.sh                                  ###
###    Author: Helmut Schmid                                    ###
###   Purpose:                                                  ###
###   Created: Wed May 24 10:52:55 2006                         ###
###  Modified: Wed May 24 10:59:18 2006 (schmid)                ###
### Copyright: Institut fuer maschinelle Sprachverarbeitung     ###
###            Universitaet Stuttgart                           ###
###                                                             ###
###################################################################

# Rules less frequent than Threshold1 are binarized
# Bigram Markov categories less frequent than Threshold2
# are replaced with unigram categories

Threshold1=60
Threshold2=25

make tmod

echo "Grammar extraction ..."
gzip -cd DATA/training.txt.gz |
./tmod -q -r -t -m symbol-mapping.txt -pm prep-mapping.txt > TB-grammar

echo "grammar transformation ..."
cmd/filter-grammar.perl TB-grammar
rm -f TB-grammar

mv grammar grammar.orig
cmd/markovize-rules.perl -t $Threshold1 -r $Threshold2 grammar.orig > grammar

cmd/extract-oc-tags.perl lexicon > open-class-tags
