
/*MA****************************************************************/
/*                                                                 */
/*     File: symbol-map.h                                          */
/*   Author: Helmut Schmid                                         */
/*  Purpose:                                                       */
/*  Created: Thu Jan  2 14:55:10 2003                              */
/* Modified: Fri Nov 13 08:30:13 2009 (schmid)                     */
/*                                                                 */
/*ME****************************************************************/

#include <string.h>

#include <ext/hash_map>
using __gnu_cxx::hash_map;
using __gnu_cxx::hash;


/*****************  class SymbolMap  *****************************/

class SymbolMap {

private:

  struct eqstr {
    bool operator()(char* s1, char* s2) const {
      return strcmp(s1, s2) == 0;
    }
  };

  typedef hash_map<char*, char*, hash<const char*>, eqstr> SM;

  SM sm;

public:

  typedef SM::iterator iterator;

  iterator find( char *s ) { return sm.find(s); }
  iterator begin() { return sm.begin(); }
  iterator end()   { return sm.end(); }
  size_t   size()  { return sm.size(); }

  char* &operator[]( char *s ) {
    iterator it=sm.find(s);
    if (it != sm.end())
      return it->second;
    return sm.insert(SM::value_type(strdup(s), NULL)).first->second;
  }
};

